//+------------------------------------------------------------------+
//|                                         RSI_Extremums_Sample.mq4 |
//|                                       Copyright  2009, TheXpert |
//|                                           theforexpert@gmail.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, TheXpert"
#property link      "theforexpert@gmail.com"

#property indicator_separate_window

#property indicator_buffers 3

#property indicator_minimum -10
#property indicator_maximum 110

#property indicator_color1  Yellow
#property indicator_color2  Red
#property indicator_color3  Blue

extern int FastMA=12;
extern int SlowMA=24;
extern int Crosses=50;

// buffers
double Values[];           // values
double Extremums_r[];        // extremums
double Extremums_b[];     

int DigitsUsed = 5;
int EmptyValueUsed = 0;

int init()
{
   SetIndexBuffer(0, Values);
   SetIndexBuffer(1, Extremums_r);
    SetIndexBuffer(2, Extremums_b);
   
   // buffers settings
   SetIndexStyle(0, DRAW_LINE);     // values are drawn as a solid line

   SetIndexStyle(1, DRAW_ARROW, STYLE_SOLID, 3);    // extremums are drawn as circles
   SetIndexArrow(1, 159);
   SetIndexStyle(2, DRAW_ARROW, STYLE_SOLID, 3);    // extremums are drawn as circles
   SetIndexArrow(2, 159);
   
   IndicatorDigits(DigitsUsed);
   
  

   return(0);
}

int start()
{
   int toCount = Bars - IndicatorCounted();  
   for (int i = toCount - 1; i >=0; i--)
   {
      Values[i] = NormalizeDouble(iCustom(Symbol(),0,"Cycle_KROUFR_version",FastMA,SlowMA,Crosses ,0, i), DigitsUsed);
   }
      
   for (i = toCount - 1; i >=0; i--)
   {
      // to check the extremum we need at least 2 older bars
      // if they are not available, there is no reason to continue
      if (i + 2 >= Bars)
      {
         continue;
      }

      // check empty values
      if (
            Values[i]      == EmptyValueUsed || 
            Values[i + 1]  == EmptyValueUsed ||
            Values[i + 2]  == EmptyValueUsed
      )
      {
         continue;
      }
      
      // clean current mark
      Extremums_r[i + 1] = EMPTY_VALUE;
      Extremums_b[i + 1] = EMPTY_VALUE;
      
      int last_dot_1_r=-1;
         for(int c=0;c<=toCount;c++)
         {
         if(Extremums_r[c]!=EMPTY_VALUE) {last_dot_1_r=1;break;}
         if(Extremums_b[c]!=EMPTY_VALUE) {last_dot_1_r=0;break;}
         }
      
      // extremum condition -- simple case
      if ((Values[i] - Values[i + 1])*(Values[i + 1] - Values[i + 2]) < 0 && last_dot_1_r==0)
      {
         // if available
         Extremums_r[i + 1] = Values[i + 1];
         continue;
      }
      
       // extremum condition -- simple case
      if ((Values[i] - Values[i + 1])*(Values[i + 1] - Values[i + 2]) < 0 && last_dot_1_r==1)
      {
         // if available
         Extremums_b[i + 1] = Values[i + 1];
         continue;
      }
      
      // extremum condition -- complicated case
      if (Values[i + 1] == Values[i + 2] && Values[i] != Values[i + 1])
      {
         // potential one is available

         int index = i + 2;
         bool found = false;
         while (index < Bars && Values[index] != EmptyValueUsed && Values[index] != EMPTY_VALUE)
         {
            if (Values[i + 2] != Values[index])
            {
               // got the end
               found = true;
               break;
            }
            
            index++;
         }

         if (!found)
         {
            // not got the end
            continue;
         }
         
         /////////////////////
         last_dot_1_r=-1;
         for(c=0;c<=toCount;c++)
         {
         if(Extremums_r[c]!=EMPTY_VALUE) {last_dot_1_r=1;break;}
         if(Extremums_b[c]!=EMPTY_VALUE) {last_dot_1_r=0;break;}
         }
         
         /////////////////
         // test the extremum
         if ((Values[i] - Values[i + 1])*(Values[i + 1] - Values[index]) < 0 && last_dot_1_r==0)
         {
            // got it
            Extremums_r[i + 1] = Values[i + 1];
         }  // got bending
         
         ///////////////
         if ((Values[i] - Values[i + 1])*(Values[i + 1] - Values[index]) < 0 && last_dot_1_r==1)
         {
            // got it
            Extremums_b[i + 1] = Values[i + 1];
         }  // got bending
         ///////
         
      }
   }
   
   return(0);
}